\begin{latin}

\begin{tikzpicture}[x=0.75pt,y=0.75pt,yscale=-1,xscale=1]
%uncomment if require: \path (0,635); %set diagram left start at 0, and has height of 635

%Shape: Rectangle [id:dp8428750508396599] 
\draw   (38.5,40) -- (120,40) -- (120,80) -- (38.5,80) -- cycle ;

%Shape: Rectangle [id:dp41122943017363855] 
\draw   (38.5,120) -- (120,120) -- (120,160) -- (38.5,160) -- cycle ;

%Shape: Rectangle [id:dp18286896609430903] 
\draw   (38.5,80) -- (120,80) -- (120,120) -- (38.5,120) -- cycle ;

%Shape: Rectangle [id:dp8430941768242757] 
\draw   (480,59) -- (541.5,59) -- (541.5,90) -- (480,90) -- cycle ;

%Rounded Rect [id:dp14650033677173635] 
\draw   (460,38.5) .. controls (460,33.81) and (463.81,30) .. (468.5,30) -- (581.5,30) .. controls (586.19,30) and (590,33.81) .. (590,38.5) -- (590,131.5) .. controls (590,136.19) and (586.19,140) .. (581.5,140) -- (468.5,140) .. controls (463.81,140) and (460,136.19) .. (460,131.5) -- cycle ;
%Shape: Rectangle [id:dp8013110079962931] 
\draw   (480,99) -- (566.81,99) -- (566.81,130) -- (480,130) -- cycle ;


%Straight Lines [id:da8358447320048874] 
\draw  [dash pattern={on 4.5pt off 4.5pt}]  (120,70) -- (480,70) ;


%Shape: Rectangle [id:dp08218155115748127] 
\draw   (40,270) -- (120,270) -- (120,310) -- (40,310) -- cycle ;

%Straight Lines [id:da37639881216745974] 
\draw  [dash pattern={on 4.5pt off 4.5pt}]  (120,110) -- (480,190) ;


%Shape: Rectangle [id:dp7558326378024458] 
\draw   (38.5,200) -- (120,200) -- (120,240) -- (38.5,240) -- cycle ;

%Shape: Rectangle [id:dp06511955395146041] 
\draw   (38.5,160) -- (120,160) -- (120,200) -- (38.5,200) -- cycle ;

%Straight Lines [id:da6032765580648329] 
\draw  [dash pattern={on 4.5pt off 4.5pt}]  (120,140) -- (480,310) ;


%Straight Lines [id:da6207720234003105] 
\draw  [dash pattern={on 4.5pt off 4.5pt}]  (120,180) -- (480,430) ;


%Straight Lines [id:da5877887170944478] 
\draw  [dash pattern={on 4.5pt off 4.5pt}]  (120,220) -- (480,550) ;


%Straight Lines [id:da6050044787272018] 
\draw  [dash pattern={on 4.5pt off 4.5pt}]  (120,290) -- (480,110) ;


%Straight Lines [id:da7759306160828217] 
\draw  [dash pattern={on 4.5pt off 4.5pt}]  (120,330) -- (480,590) ;


%Straight Lines [id:da917937934178173] 
\draw  [dash pattern={on 4.5pt off 4.5pt}]  (120,330) -- (480,470) ;


%Straight Lines [id:da2985426323823046] 
\draw  [dash pattern={on 4.5pt off 4.5pt}]  (120,290) -- (480,230) ;


%Straight Lines [id:da731242890847617] 
\draw  [dash pattern={on 4.5pt off 4.5pt}]  (120,290) -- (480,350) ;


%Shape: Rectangle [id:dp6859792422331472] 
\draw   (480,179) -- (541.5,179) -- (541.5,210) -- (480,210) -- cycle ;

%Rounded Rect [id:dp21552340668861225] 
\draw   (460,158.5) .. controls (460,153.81) and (463.81,150) .. (468.5,150) -- (581.5,150) .. controls (586.19,150) and (590,153.81) .. (590,158.5) -- (590,251.5) .. controls (590,256.19) and (586.19,260) .. (581.5,260) -- (468.5,260) .. controls (463.81,260) and (460,256.19) .. (460,251.5) -- cycle ;
%Shape: Rectangle [id:dp9417222000952608] 
\draw   (480,219) -- (566.81,219) -- (566.81,250) -- (480,250) -- cycle ;


%Shape: Rectangle [id:dp6836943125557202] 
\draw   (480,299) -- (541.5,299) -- (541.5,330) -- (480,330) -- cycle ;

%Rounded Rect [id:dp797949471468343] 
\draw   (460,278.5) .. controls (460,273.81) and (463.81,270) .. (468.5,270) -- (581.5,270) .. controls (586.19,270) and (590,273.81) .. (590,278.5) -- (590,371.5) .. controls (590,376.19) and (586.19,380) .. (581.5,380) -- (468.5,380) .. controls (463.81,380) and (460,376.19) .. (460,371.5) -- cycle ;
%Shape: Rectangle [id:dp433345807152393] 
\draw   (480,339) -- (566.81,339) -- (566.81,370) -- (480,370) -- cycle ;


%Shape: Rectangle [id:dp03354879456209403] 
\draw   (480,419) -- (541.5,419) -- (541.5,450) -- (480,450) -- cycle ;

%Rounded Rect [id:dp9762110003452296] 
\draw   (460,398.5) .. controls (460,393.81) and (463.81,390) .. (468.5,390) -- (581.5,390) .. controls (586.19,390) and (590,393.81) .. (590,398.5) -- (590,491.5) .. controls (590,496.19) and (586.19,500) .. (581.5,500) -- (468.5,500) .. controls (463.81,500) and (460,496.19) .. (460,491.5) -- cycle ;
%Shape: Rectangle [id:dp9527383858337823] 
\draw   (480,459) -- (566.81,459) -- (566.81,490) -- (480,490) -- cycle ;


%Shape: Rectangle [id:dp09181938165340808] 
\draw   (480,539) -- (541.5,539) -- (541.5,570) -- (480,570) -- cycle ;

%Rounded Rect [id:dp8813069377902596] 
\draw   (460,518.5) .. controls (460,513.81) and (463.81,510) .. (468.5,510) -- (581.5,510) .. controls (586.19,510) and (590,513.81) .. (590,518.5) -- (590,611.5) .. controls (590,616.19) and (586.19,620) .. (581.5,620) -- (468.5,620) .. controls (463.81,620) and (460,616.19) .. (460,611.5) -- cycle ;
%Shape: Rectangle [id:dp024987314559172136] 
\draw   (480,579) -- (566.81,579) -- (566.81,610) -- (480,610) -- cycle ;


%Shape: Rectangle [id:dp1616183588894684] 
\draw   (40,309) -- (120,309) -- (120,350) -- (40,350) -- cycle ;


% Text Node
\draw (79.25,60) node  [align=left] {Peer 1};
% Text Node
\draw (79.25,140) node  [align=left] {Peer 3};
% Text Node
\draw (79.25,100) node  [align=left] {Peer 2};
% Text Node
\draw (81,11) node  [align=left] {Server side};
% Text Node
\draw (510.75,74.5) node  [align=left] {Peer 1};
% Text Node
\draw (523.4,114.5) node  [align=left] {Shared 1};
% Text Node
\draw (80,290) node  [align=left] {Shared 1};
% Text Node
\draw (79.25,180) node  [align=left] {Peer 4};
% Text Node
\draw (79.25,220) node  [align=left] {Peer 5};
% Text Node
\draw (492.5,39) node  [align=left] {Client 1};
% Text Node
\draw (492.5,159) node  [align=left] {Client 2};
% Text Node
\draw (523.4,234.5) node  [align=left] {Shared 1};
% Text Node
\draw (510.75,194.5) node  [align=left] {Peer 2};
% Text Node
\draw (492.5,279) node  [align=left] {Client 3};
% Text Node
\draw (523.4,354.5) node  [align=left] {Shared 1};
% Text Node
\draw (510.75,314.5) node  [align=left] {Peer 3};
% Text Node
\draw (492.5,399) node  [align=left] {Client 4};
% Text Node
\draw (523.4,474.5) node  [align=left] {Shared 2};
% Text Node
\draw (510.75,434.5) node  [align=left] {Peer 4};
% Text Node
\draw (492.5,519) node  [align=left] {Client 5};
% Text Node
\draw (523.4,594.5) node  [align=left] {Shared 2};
% Text Node
\draw (510.75,554.5) node  [align=left] {Peer 5};
% Text Node
\draw (80,329.5) node  [align=left] {Shared 2};


\end{tikzpicture}



\end{latin}